package icu.wjz;

import static org.junit.Assert.assertTrue;

import icu.wjz.entity.dto.user.UserDTO;
import icu.wjz.service.UserService;
import icu.wjz.util.UserThread;
import org.apache.catalina.User;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.junit4.SpringRunner;
import org.springframework.transaction.PlatformTransactionManager;
import org.springframework.transaction.TransactionStatus;
import org.springframework.transaction.support.TransactionTemplate;

import javax.annotation.Resource;


@SpringBootTest(classes = App.class)
@RunWith(SpringRunner.class)
public class AppTest {

    @Autowired
    private UserService userService;
    @Resource
    private TransactionTemplate transactionTemplate;


    @Test
    public void test1(){
        UserDTO user = new UserDTO();
        user.setAge(11);
        user.setName("wangsichu1");
        userService.a1(user);

    }

    @Test
    public void test2(){
        UserDTO user = new UserDTO();
        user.setAge(12);
        user.setName("wangsichu2");
        userService.a2(user);
    }

    @Test
    public void test3(){
        UserDTO user = new UserDTO();
        user.setAge(13);
        user.setName("wangsichu3");
        userService.a3(user);
    }

    @Test
    public void test4(){
        UserDTO user = new UserDTO();
        user.setAge(14);
        user.setName("wangsichu4");
        userService.a4(user);
    }

    @Test
    public void test5(){
        UserDTO user = new UserDTO();
        user.setAge(15);
        user.setName("wangsichu5");
        userService.a5(user);
    }

    @Test
    public void synTest1(){

        for(int i = 0; i< 3; i++){
            UserThread userThread = new UserThread();
            userThread.setUserService(userService);
            Thread thread = new Thread(userThread);

            thread.start();
            try {
                Thread.sleep(2000);
            } catch (InterruptedException e) {
                e.printStackTrace();
            }
        }

    }

    @Test
    public void synTest2(){

        int j = 0;
        for(int i = 0; i < 1000; i++){
            synchronized ("aaa"){
                j += 1;
            }
        }

        System.out.println("计算后的值为:"+ j);
    }

    @Test
    public void t1(){

    }
}
